#include <stdio.h>
#include "defs.h"

har *progname;
har *filename;
ixrect *pr;

#ifdef STANDALONE
ain(argc, argv, envp)
#else
asinfo_main(argc, argv, envp)
#endif
	int argc;
	char **argv;
	char **envp;
{
	int i;
	int print_cmap = FALSE, print_size = TRUE;
	colormap_t colormap;

	progname = strsave(argv[0]);
	parse_profile(&argc, argv, envp);

	while ((gc = getopt(argc, argv, "nc")) != EOF)
		switch (gc) {
		case 'n':
			print_size = FALSE;
			break;
		case 'c':
			print_cmap = TRUE;
			break;
		case '?':
			errflag++;
			break;
		}

	if (errflag)
		error((char *) 0, "Usage: %s: [-c] [infile]\n", progname);

	for (stream = 0; optind < argc; stream++, optind++)
		if (stream == 0 && strcmp(argv[optind], "-") != 0)
			if (freopen(argv[optind], mode[stream], f[stream]) == NULL)
				error("%s %s", PR_IO_ERR_INFILE, argv[optind]);

	if ((pr = pr_load(stdin, &colormap)) == NULL)
		error(PR_IO_ERR_RASREAD);

	if (print_size) {
	    printf("xsize = %d\n", pr->pr_size.x);
	    printf("ysize = %d\n", pr->pr_size.y);
	    printf("depth = %d\n", pr->pr_depth);
	}

	if (print_cmap) {
		printf("Colourmap length = %d\n", colormap.length);
		if (colormap.length == 0)
			printf("No colourmap associated with image - ALV tools assume greyscale\n");
		else
			for (i = 0; i < colormap.length; i++)
				printf("%d: %d %d %d\n", i, colormap.map[0][i], colormap.map[1][i], colormap.map[2][i]);
	}
}
