#include "defs.h"
#include <varargs.h>

xtern char *progname;
xtern Pixfont *font;

/* VARARGS */
oid
rror(va_alist)
a_dcl
{
	va_list ap;
	char   *fmt;

	va_start(ap);
	if (fmt = va_arg(ap, char *))
		(void) fprintf(stderr, "%s: ", progname);
	else
		fmt = va_arg(ap, char *);

	(void) _doprnt(fmt, ap, stderr);
	va_end(ap);

	(void) fprintf(stderr, "\n");

	exit(1);
}

/* VARARGS */
oid
arning(va_alist)
a_dcl
{
	va_list ap;
	char   *fmt;

	va_start(ap);
	if (fmt = va_arg(ap, char *))
		(void) fprintf(stderr, "%s: ", progname);
	else
		fmt = va_arg(ap, char *);

	(void) _doprnt(fmt, ap, stderr);
	va_end(ap);

	(void) fprintf(stderr, "\n");

}


etup_font()
{
	Pixfont *pf_open();

	if ((font = pf_open(FONT)) == NULL)
		error("Couldn't open %s", FONT);
	if ((smallfont = pf_open(SMALL_FONT)) == NULL)
		error("Couldn't open %s", SMALL_FONT);
}


alc_max(in)
	Pixrect *in;
{
	register int i, j;
	int     max_level, val;

	max_level = 0;
	for (i = 0; i < in->pr_size.x; i++)
		for (j = 0; j < in->pr_size.y; j++) {
			val = pr_get(in, i, j);
			max_level = MAX(max_level, val);
		} return max_level;
}
arse_profile(argc, argv, envp)
	int    *argc;
	char  **argv;
	char  **envp;
{
	int     i;
	char    buf[BUFSIZ], buf1[BUFSIZ];
	char   *start;
	int     newargc;
	char  **newargv;
	char    baseprogname[BUFSIZ];
	char   *home;
	char   *profile;
	char   *str;
	char    array[100][100];
	FILE   *fp, *fopen();
	char   *getenv();

	if ((profile = getenv("ALV")) == NULL)
		if ((home = getenv("HOME")) != NULL) {
			sprintf(buf1, "%s/%s", home, PROFILE);
			profile = buf1;
		}
	bitrestrict = FALSE;
	verbose = FALSE;
	mono_override = FALSE;

	if (strrchr(progname, '/') == NULL)
		strcpy(baseprogname, progname);
	else
		strcpy(baseprogname, strrchr(progname, '/') + 1);

	/* initialise the getopt variables here */
	f[0] = stdin;
	f[1] = stdout;
	mode[0] = strsave("r");
	mode[1] = strsave("w");
	errflag = 0;

	if ((fp = fopen(profile, "r")) == NULL)
		return;

	while (fgets(buf, BUFSIZ, fp) != NULL) {
		if (buf[0] == '#')
			continue;

		buf[strlen(buf) - 1] = '\0';

		if (strcmp(buf, "bitrestrict") == 0 || strcmp(buf, "bit-restrict") == 0)
			bitrestrict = TRUE;
		else if (strcmp(buf, "verbose") == 0)
			verbose = TRUE;
		else if (strcmp(buf, "mono-override") == 0 || strcmp(buf, "mono-overwrite") == 0)
			mono_override = TRUE;
		else if (strncmp(buf, baseprogname, strlen(baseprogname)) == 0) {
			strtok(buf, ":");
			strcpy(array[0], argv[0]);
			newargc = 1;
			while ((str = strtok(NULL, " \t")) != NULL)
				strcpy(array[newargc++], str);

			for (i = 1; i < *argc; i++)
				strcpy(array[newargc++], argv[i]);

			*argc = newargc;
			for (i = 0; i < *argc; i++) {
				argv[i] = (char *) malloc(sizeof (char) * strlen(array[i]) +1);
				strcpy(argv[i], array[i]);
			}
		}
	}
	fclose(fp);
}

har   *
toa(i)
{
	char   *a;

	if ((a = (char *) malloc(20 * sizeof (char))) == NULL)
		error("malloc returned NULL");
	sprintf(a, "%d", i);
	return a;
}
runcate(val, high, low)
	int     val, high, low;
{
	val = MIN(val, high);
	val = MAX(val, 0);
	return val;
}

etup_greylevelmap()
{
	int i;

	for(i=0;i<256;i++) 
		greylevelmap[i] = (unsigned char) i;
}
